#!/usr/bin/env python

import os, sys

results = {}

for file_name in os.listdir("."):
	if file_name.find("_") != -1:
		file = open(file_name, "r")
		test, test_iter = file_name.split("_")
		if test_iter == "0":
			continue

		file.readline() # # START
		file.readline() # ! S FLASH
		file.readline() # ! E FLASH
		file.readline() # ! S BOOT
		start = float(file.readline().split()[3]) # ! E BOOT TS_WALL TS_REAL

		line = file.readline()
		while line != '':
			dump = line.split()[3] # ! S DUMP INTERVAL TS_WALL TS_REAL
			dump = int(dump)

			while file.readline()[0] != '\n':
				pass

			line = file.readline()
			while line[0] != "!":
				cstate = line.split(":")[0]
				try:
					results[dump]
				except KeyError:
					results[dump] = {}
				try:
					results[dump][test]
				except KeyError:
					results[dump][test] = {}
				try:
					results[dump][test][cstate]
				except KeyError:
					results[dump][test][cstate] = {}
				try:
					iter = results[dump][test][cstate]["iter"]
					results[dump][test][cstate]["iter"] += 1
				except KeyError:
					iter = 1
					results[dump][test][cstate]["iter"] = 1
				l1 = file.readline()
				l2 = file.readline()
				try:
					#if results[dump][test][cstate]["count"] > 0:
					#	print test + "\t" + cstate + "\t" + str(iter) + "\t" + str(results[dump][test][cstate]["count"]) + "\t" + l1.split()[1]
					results[dump][test][cstate]["count"] = ((results[dump][test][cstate]["count"] * iter) + int(l1.split()[1])) / (iter + 1)
					results[dump][test][cstate]["time"]  = ((results[dump][test][cstate]["time"]  * iter) + float(l2.split()[1])) / (iter + 1)
				except KeyError:
					results[dump][test][cstate]["count"] = float(l1.split()[1])
					results[dump][test][cstate]["time"]  = float(l2.split()[1])

				line = file.readline()
				while line[0] == " ":
					line = file.readline()

			end = float(line.split()[4])

			try:
				results[dump][test]["runtime"] += end - start
			except KeyError:
				results[dump][test]["runtime"] = end - start

			line = file.readline()

dumps = results.keys()
dumps.sort()

tests_t = results.values()[0].keys()
tests = []
for t in ("origin", "over1000", "over500", "over100", "equal100", "equal50"):
	try:
		tests_t.pop(tests_t.index(t))
		tests.append(t)
	except ValueError:
		pass
assert len(tests_t) == 0

for dump in dumps:
	print "/" * 80
	for test in tests:
		results[dump][test]["runtime"] /= results[dump][test].values()[0]["iter"]
		if True:
			if test == "origin":
				print "=== " + test + \
						" (" + str(results[dump][test].values()[0]["iter"]) + " samples) " + \
						"=" * (80 - 4 - len(test) - 10 - len(str(results[dump][test].values()[0]["iter"])) - 2 - len(" runtime: ") - len(str(results[dump][test]["runtime"])) - 4) + \
						" RUNTIME: " + str(results[dump][test]["runtime"]) + " ==="
			else:
				delta = results[dump][test]["runtime"] - results[dump]["origin"]["runtime"]
				print "=== " + test + \
						" (" + str(results[dump][test].values()[0]["iter"]) + " samples) " + \
						"=" * (80 - 4 - len(test) - 10 - len(str(results[dump][test].values()[0]["iter"])) - 2 - \
						len(" runtime: ") - len(str(results[dump][test]["runtime"])) - len(" (delta: ") - len(str(delta)) - 5) + \
						" (delta: " + str(delta) + ") RUNTIME: " + str(results[dump][test]["runtime"]) + " ==="
		else:
			print "=== " + test + " (" + str(results[dump][test].values()[0]["iter"]) + " samples) " + "=" * (80 - 4 - 2 - len(test) - len(str(results[dump][test].values()[0]["iter"])) - 10)
		for cstate in results[dump][test]:
			if cstate == "runtime":
				continue
			if results[dump][test][cstate]["count"] == 0:
				continue

			print str(dump) + "\t",
			print cstate + " " * (13 - len(cstate)) + "--\t",
			print str(results[dump][test][cstate]["count"]) + " " * (16 - len(str(results[dump][test][cstate]["count"]))),
			#print str(results[dump][test][cstate]["count"] / results[dump][test]["runtime"]) + "\t",
			#print str(results[dump][test][cstate]["count"] / results[dump][test][cstate]["time"]) + "\t",
			print str(results[dump][test][cstate]["time"]) + " " * (16 - len(str(results[dump][test][cstate]["time"]))),
			#print str(results[dump][test][cstate]["time"]  / results[dump][test]["runtime"]) + "\t",
			if test != "origin":
				print "\t|",
				delta = results[dump][test][cstate]["time"] - results[dump]["origin"][cstate]["time"]
				print str(delta),
			print

if len(sys.argv) == 1:
	exit()

print
# GNUPLOT:
# [[dump, count], [dump, count], [dump, count]]

arrays = {}

for dump in dumps:
	for test in results[dump]:
		if test == "origin":
			continue
		for cstate in results[dump][test]:
			if cstate == "runtime":
				continue
			if results[dump][test][cstate]["count"] == 0:
				continue

			try:
				arrays[cstate]
			except KeyError:
				arrays[cstate] = {}

			delta = results[dump][test][cstate]["time"] - results[dump]["origin"][cstate]["time"]
			a = [dump, delta]
			try:
				arrays[cstate][test].append(a)
			except KeyError:
				arrays[cstate][test] = [a]

import Gnuplot

for cstate in arrays:
	print "Plotting ", cstate
	g = Gnuplot.Gnuplot(persist = 1)
	g("set title " + cstate)
	g("set xrange [0:250]")
	#g("set logscale y")
	g("set key default")

	plots = []
	mn = 10000000000
	mx = 0
	for test in arrays[cstate]:
		for dump,count in arrays[cstate][test]:
			mn = min(mn, count)
			mx = max(mx, count)
		#print test + "\t" + str(arrays[cstate][test]) + "\t\t" + str(mn) + ":" + str(mx)
		plots.append(Gnuplot.PlotItems.Data(arrays[cstate][test], with_="lines", title=test))
	ymn = mn - mn*.05
	ymx = mx + mx*.05
	g("set yrange [" + str(ymn) + ":" + str(ymx) + "]")

	# Weird interface to plot()...
	if len(plots) == 1:
		g.plot(plots[0], title=cstate)
	elif len(plots) == 2:
		g.plot(plots[0], plots[1], title=cstate)
	elif len(plots) == 3:
		g.plot(plots[0], plots[1], plots[2], title=cstate)
	elif len(plots) == 4:
		g.plot(plots[0], plots[1], plots[2], plots[3], title=cstate)
	elif len(plots) == 5:
		g.plot(plots[0], plots[1], plots[2], plots[3], plots[4], title=cstate)
	elif len(plots) == 6:
		g.plot(plots[0], plots[1], plots[2], plots[3], plots[4], plots[5], title=cstate)
	g("set term postscript enhanced color")
	g.hardcopy(filename=(cstate+".ps"))
	print "Done plotting ", cstate
